//1.gzh_2019_esti_A  változat megoldása
//Változtatás: a kedvenc TV csatorna nem a sor végén van megadva, hanem a sor elején
//Ez jellemzõbb sor szerkezet
//
//Ha osztalyok.h-ban a #define TESZT aktív, akkor a programozási tételek által feldolgozott adatokat
//kiírja, így nyomon követhető az összesítés helyessége és a felsoroló helyessége
#include <iostream>
#include <fstream>
#include "osztalyok.h"
#include "library/seqinfileenumerator.hpp"

using namespace std;

void megfelelt(const string& file);
void kivalo(const string& file);

int main(int argc, char* argv[])
{
    string file;
    try{
        //Input fajl megnyitas
        if(argc==2)
        {
            file=argv[1];
        }else{
            cout<<"Kerem a fajl nevet:"; cin>>file;
        }
        megfelelt(file);
        kivalo(file);
    }catch(SeqInFileEnumerator<sor>::Exceptions err)
    {
        if(err==SeqInFileEnumerator<sor>::OPEN_ERROR)
        {
            cout<<file<<" nem elerheto!\n";
        }
    }
    return 0;
}

void megfelelt(const string& file)
{
    SeqInFileEnumerator<sor> enor(file);
    feltMax pr;
    pr.addEnumerator(&enor);
    pr.run();
    cout<<"Megfelelt szint eredmenye:\n";
    if(pr.found())
    {
        cout<<"A legtobbet tevezett: "<<pr.optElem().id<<" osszesen: "<<pr.opt()<<" percet.\n";
    }else{
        cout<<"Nem volt olyan nezo, aki a felteteleknek megfelelt.\n";
    }
}

void kivalo(const string& file)
{
    sajatEnumerator enor(file);
    linKer pr;
    pr.addEnumerator(&enor);
    pr.run();
    cout<<"Kivalo szint eredmenye:\n";
    if(pr.found())
    {
        cout<<"Talaltam megfelelo nezot: "<<pr.elem().id<<endl;
    }else{
        cout<<"Nem volt megfelelo nezo.\n";
    }
}
